//
//  AppDelegate.m
//  UnitidSmartLiveSDKDemo
//
//  Created by 张鹤 on 2020/6/24.
//  Copyright © 2020 张鹤. All rights reserved.
//

#import "AppDelegate.h"
#import "ViewController.h"
#import <LiveDetectionSDKFrame/LiveDetectionSDKFrame.h>



#define FACE_LICENSE_NAME  @"idl-license"

#define FACE_LICENSE_SUFFIX  @"face-ios"

#define FACE_LICENSE_ID  @"shizhu-enterprise-face-ios"




@interface AppDelegate ()

@end

@implementation AppDelegate

// cn.unitid.spideriddetection

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
   
//    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    
    NSString* licensePath = [NSString stringWithFormat:@"%@.%@", FACE_LICENSE_NAME, FACE_LICENSE_SUFFIX];

    [[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleLightContent];
    
    [UnitidLiveSDKManager setLicenseID:FACE_LICENSE_ID andLocalLicenceFile:licensePath];
    
    BOOL isCanWork = [UnitidLiveSDKManager canWork];
//    [UnitidLiveSDKManager sharedInstance]
    ViewController *vc = [[ViewController alloc] init];
    UINavigationController *nav = [[UINavigationController alloc] initWithRootViewController:vc];

    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *appearance = [[UINavigationBarAppearance alloc] init];
        appearance.backgroundColor = [UIColor blackColor];
        appearance.titleTextAttributes = @{NSFontAttributeName:[UIFont systemFontOfSize:17],NSForegroundColorAttributeName:[UIColor whiteColor]};
        nav.navigationBar.scrollEdgeAppearance = appearance;
        nav.navigationBar.standardAppearance = appearance;

        
    } else {
        // Fallback on earlier versions
        
        [nav.navigationBar setBarTintColor:[UIColor blackColor]];
        [nav.navigationBar setTitleTextAttributes:[NSDictionary dictionaryWithObjectsAndKeys:[UIColor whiteColor],NSForegroundColorAttributeName,
         [UIFont systemFontOfSize:18],NSFontAttributeName,nil]];
    }
   
    
  
    
    
    self.window.rootViewController = nav;
    [self.window makeKeyAndVisible];
    
    
    return YES;
}



@end
