//
//  UntitedNetworkHelper.h
//  TestLiveFrameDemo
//
//  Created by artmkt on 2021/5/27.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef void (^NWCompletioBlock)(NSDictionary *dic, NSURLResponse *response, NSError *error);
typedef void (^NWSuccessBlock)(NSDictionary *data);
typedef void (^NWSuccessWithResponCodeBlock)(NSDictionary *data,NSInteger code);

typedef void (^NWFailureBlock)(NSError *error);
typedef void (^NWBodyFailureBlock)(NSDictionary *errorDic);



@interface UntitedNetworkHelper : NSObject

@property (nonatomic,copy) NSString *requestUrl;

+ (instancetype)shareInstance;
/**
 * @brief   GET请求方法
 * @author  yuancan
 
 * @param relativePath 接口名称
 * @param params 请求参数
 * @param successBlock 请求成功回调
 * @param failBlock 请求失败回调
 */
- (void)requestGET:(NSString *)relativePath body:(NSDictionary *)params successBlock:(NWSuccessBlock )successBlock failBlock:(NWFailureBlock)failBlock;


/**
 * @brief   POST请求方法
 * @author  yuancan
 
 * @param relativePath 接口名称
 * @param params 请求参数
 * @param successBlock 请求成功回调
 * @param failBlock 请求失败回调
 */
- (void)requestPOST:(NSString *)relativePath params:(NSDictionary *)params successBlock:(NWSuccessBlock)successBlock failBlock:(NWFailureBlock)failBlock;

@end

NS_ASSUME_NONNULL_END
