//
//  ViewController.m
//  UnitidSmartLiveSDKDemo
//
//  Created by 张鹤 on 2020/6/24.
//  Copyright © 2020 张鹤. All rights reserved.
//

#import "ViewController.h"
#import <LiveDetectionSDKFrame/LiveDetectionSDKFrame.h>
#import <CommonCrypto/CommonDigest.h>
#import <CommonCrypto/CommonHMAC.h>
#import "SVProgressHUD.h"
#import "SingleSelectTableViewCell.h"
#import "UntitedNetworkHelper.h"



#define SDKKey1 @"123456"
#define SDKKey2 @"654321"



@interface ViewController ()<UITextFieldDelegate,UnitidLiveSDKDelegate,UITableViewDelegate, UITableViewDataSource,SpiderEntAuthDelegate>


@property (nonatomic, strong)NSArray *array;
@property (nonatomic, strong)UITableView *functionTableView;

@property (nonatomic, strong)UITextField *tokenTextField;
@property (nonatomic, strong)UILabel  *tokenLabel;

@property (nonatomic, strong)UITextField *resultTextField;
@property (nonatomic, strong)UILabel *resultLabel;

@property (nonatomic, strong)UILabel  *line1;
@property (nonatomic, strong)UILabel  *line2;

@property (nonatomic, strong)NSMutableArray *actionArray;

@property (nonatomic, strong)UIButton  *startButton;

@end

@implementation ViewController

- (void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden = NO;
    
}
- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    [[UINavigationBar appearance] setTranslucent:YES];

}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    self.navigationItem.title = @"身份认证";
    
    self.array = @[@"眨眼睛",@"张大嘴",@"右摇头",@"左摇头",@"向上抬头",@"向下低头"];
    [self.view addSubview: self.functionTableView];
//    self.extendedLayoutIncludesOpaqueBars = YES;

    NSLog(@"");
    

}

- (void)viewWillLayoutSubviews{
        
    [super viewWillLayoutSubviews];
    
    self.functionTableView.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height);
    

        
//    self.startButton.frame = CGRectMake(30, CGRectGetMaxY(_lineLabel.frame) + 200, [UIScreen mainScreen].bounds.size.width - 60, 45);
    
}


- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    [self.view endEditing:YES];
    return YES;
}


- (void)gotoStartButton{
    if (_tokenTextField.text.length == 0) {

        return;
    }

    LivingConfigModel *model = [LivingConfigModel sharedInstance];
    model.isByOrder = YES;
    model.liveActionArray = [NSMutableArray arrayWithArray:_actionArray];
    model.numOfLiveness = _actionArray.count;

    model.token =  _tokenTextField.text;


    UnitidVerificatedViewController *vertificateVC = [[UnitidVerificatedViewController alloc] init];
    vertificateVC.delegate = self;
    vertificateVC.extendedLayoutIncludesOpaqueBars = YES;
    [self.navigationController pushViewController:vertificateVC animated:YES];
    
   
}
- (void)gotoEnterpriseButtonStartButton{
    
    if (self.tokenTextField.text.length == 0) {
        return;;
    }
    
    LivingConfigModel *model = [LivingConfigModel sharedInstance];
    model.isByOrder = YES;
    model.liveActionArray = [NSMutableArray arrayWithArray:_actionArray];
    model.numOfLiveness = _actionArray.count;
    
    model.token =  _tokenTextField.text;
    SpiderBridgeViewController *spiderVC = [[SpiderBridgeViewController alloc] init];
    spiderVC.delegate = self;
    spiderVC.navColor = [UIColor orangeColor];
    [self.navigationController pushViewController:spiderVC animated:YES];
   
}
- (void)spiderEntAuthenticControllerDidGetResult:(SpiderEntResponseCode)result{
    self.tokenTextField.text = @"";
    if ( result == SpiderEntResponse_Action) {
        _resultTextField.text = @"核验未完成！";
    }else if (result == SpiderEntResponse_Over){
        _resultTextField.text = @"核验完成！";

    }else if (result == SpiderEntResponse_Invalid){
        _resultTextField.text = @"核验失效！";

    }else if (result == SpiderEntResponse_Error){
        _resultTextField.text = @"请检查网络或token";

    }
}
- (void)hyLivenessDetectionControllerDidGetResult:(SpiderIDResultCode)result{
    NSLog(@"resultCode === %lu",(unsigned long)result);
    self.tokenTextField.text = @"";
    if (result == SpiderIDCodeOK) {
        _resultTextField.text = @"核验成功";
        
    }else if (result == SpiderIDCodeMANUAL_AUDIT){
        _resultTextField.text = @"人工申请提交成功";

    }else if (result == SpiderIDCodeCANCEL){
        _resultTextField.text = @"用户取消操作";

    }else if (result == SpiderIDCodeINVAILD_TOKEN){
        _resultTextField.text = @"无效的token";

    }else if (result == SpiderIDCodeINVAILD_TPAGETOKEN){
        _resultTextField.text = @"获取页面会话token失败";

    }else if (result == SpiderIDCodeINVAILD_FAILURE){
        _resultTextField.text = @"其他请求失败！";

    }
}



- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _array.count;
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    return 50;
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 120 + 20;
    
}
- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 80 + 70;
    
}
- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section{
   
    UIView *headView = [[UIView alloc] initWithFrame:CGRectMake(10, 0, [UIScreen mainScreen].bounds.size.width - 20, 140)];
    headView.backgroundColor = [UIColor whiteColor];
    
    [headView addSubview:self.tokenLabel];
    [headView addSubview:self.tokenTextField];
    [headView addSubview:self.resultLabel];
    [headView addSubview:self.resultTextField];
    
    [headView addSubview:self.line1];
    [headView addSubview:self.line2];
    
    self.tokenLabel.frame = CGRectMake(0, 0, 100, 50);
    self.tokenTextField.frame = CGRectMake(100, 0, [UIScreen mainScreen].bounds.size.width - 110, 50);
    
    self.resultLabel.frame = CGRectMake(0, 50, 100, 40);
    self.resultTextField.frame = CGRectMake(100, 50, [UIScreen mainScreen].bounds.size.width - 110, 40);
    
    self.line1.frame = CGRectMake(100, CGRectGetMaxY(_tokenLabel.frame), [UIScreen mainScreen].bounds.size.width - 130, 1);
    self.line2.frame = CGRectMake(100, CGRectGetMaxY(_resultLabel.frame), [UIScreen mainScreen].bounds.size.width - 130, 1);

    UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(_line2.frame) + 10, [UIScreen mainScreen].bounds.size.width - 20, 30)];
    titleLabel.font = [UIFont systemFontOfSize:12];
    titleLabel.text = @"  - 选择认证模式";
    [headView addSubview:titleLabel];
    
    return headView;
}
- (UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section{
    UIView *buttonView;
    buttonView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 80)];
        
    buttonView.backgroundColor = [UIColor whiteColor];
    
    UIButton *personalButton = [[UIButton alloc] initWithFrame:CGRectMake(10, 20, [UIScreen mainScreen].bounds.size.width - 20, 45)];
    [buttonView addSubview:personalButton];
    [personalButton setTitle:@"个人认证" forState:UIControlStateNormal];
    [personalButton addTarget:self action:@selector(gotoStartButton) forControlEvents:UIControlEventTouchUpInside];
    [personalButton setBackgroundColor:[UIColor blueColor]];
    personalButton.titleLabel.font = [UIFont systemFontOfSize:14];
    [personalButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        
    UIButton *enterpriseButton = [[UIButton alloc] initWithFrame:CGRectMake(10, CGRectGetMaxY(personalButton.frame) + 10, [UIScreen mainScreen].bounds.size.width - 20, 45)];
    [buttonView addSubview:enterpriseButton];
    [enterpriseButton setTitle:@"企业认证" forState:UIControlStateNormal];
    [enterpriseButton addTarget:self action:@selector(gotoEnterpriseButtonStartButton) forControlEvents:UIControlEventTouchUpInside];
    [enterpriseButton setBackgroundColor:[UIColor blueColor]];
    enterpriseButton.titleLabel.font = [UIFont systemFontOfSize:14];
    [enterpriseButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        
 
    return buttonView;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *selectedIdentify = @"selectedIdentify";
    
    NSString *actionStr = _array[indexPath.row];
    SingleSelectTableViewCell *selectedCell = [_functionTableView dequeueReusableCellWithIdentifier:selectedIdentify];
    if (selectedCell == nil) {
        selectedCell = [[SingleSelectTableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:selectedIdentify];
    }
    selectedCell.titleLabel.text = actionStr;
    if ([_actionArray containsObject:[NSNumber numberWithInteger:indexPath.row]]) {
        [selectedCell.iconButton setImage:[UIImage imageNamed:@"RadioButton-Selected.png"] forState:UIControlStateNormal];

    }else{
        [selectedCell.iconButton setImage:[UIImage imageNamed:@"RadioButton-Unselected.png"] forState:UIControlStateNormal];

    }
   
    selectedCell.selectionStyle = UITableViewCellSelectionStyleNone;
    return selectedCell;
    
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
        
    if (![self.actionArray containsObject:[NSNumber numberWithInteger:indexPath.row]]) {
        [self.actionArray addObject:[NSNumber numberWithInteger:indexPath.row]];
    }else{
        [self.actionArray removeObject:[NSNumber numberWithInteger:indexPath.row]];
    }
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    [_functionTableView reloadData];
        
        
}

- (UITextField *)tokenTextField{
    if (_tokenTextField == nil) {
        _tokenTextField = [[UITextField alloc] initWithFrame:CGRectZero];
        _tokenTextField.font = [UIFont systemFontOfSize:14];
        _tokenTextField.textColor = [UIColor blackColor];
        _tokenTextField.backgroundColor = [UIColor whiteColor];
        _tokenTextField.returnKeyType = UIReturnKeyDone;
        _tokenTextField.delegate = self;
        _tokenTextField.text = @"ee21fdc7d9f2b0cc24202e9a401eb3f9c98dadb636efa8ba401a55c65d31cfca";
    }
    return _tokenTextField;
}
- (UILabel *)tokenLabel{
    if (_tokenLabel == nil) {
        _tokenLabel = [[UILabel alloc] initWithFrame:CGRectZero];
        _tokenLabel.font = [UIFont systemFontOfSize:12];
        _tokenLabel.textColor = [UIColor blackColor];
        _tokenLabel.backgroundColor = [UIColor whiteColor];
        _tokenLabel.text= @"测试token";
        _tokenLabel.textAlignment = NSTextAlignmentCenter;
        
    }
    return _tokenLabel;
}

- (UITextField *)resultTextField{
    if (_resultTextField == nil) {
        _resultTextField = [[UITextField alloc] initWithFrame:CGRectZero];
        _resultTextField.font = [UIFont systemFontOfSize:14];
        _resultTextField.textColor = [UIColor blackColor];
        _resultTextField.backgroundColor = [UIColor whiteColor];
        _resultTextField.returnKeyType = UIReturnKeyDone;
        _resultTextField.delegate = self;
        _resultTextField.text = @"";
    }
    return _resultTextField;
}
- (UILabel *)resultLabel{
    if (_resultLabel == nil) {
        _resultLabel = [[UILabel alloc] initWithFrame:CGRectZero];
        _resultLabel.font = [UIFont systemFontOfSize:12];
        _resultLabel.textColor = [UIColor blackColor];
        _resultLabel.backgroundColor = [UIColor whiteColor];
        _resultLabel.text= @"认证结果";
        _resultLabel.textAlignment = NSTextAlignmentCenter;
        
    }
    return _resultLabel;
}
- (UILabel *)line1{
    if (_line1 == nil) {
        _line1 = [[UILabel alloc] initWithFrame:CGRectZero];
        _line1.backgroundColor = [UIColor grayColor];
        _line1.textAlignment = NSTextAlignmentCenter;
    }
    return _line1;
}
- (UILabel *)line2{
    if (_line2 == nil) {
        _line2 = [[UILabel alloc] initWithFrame:CGRectZero];
        _line2.backgroundColor = [UIColor grayColor];
        _line2.textAlignment = NSTextAlignmentCenter;
    }
    return _line2;
}
- (UITableView *)functionTableView{
    if (_functionTableView == nil) {
        _functionTableView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStyleGrouped];
        _functionTableView.delegate = self;
        _functionTableView.dataSource = self;
        _functionTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        [self.view addSubview:_functionTableView];
    }
    return _functionTableView;
}
- (UIButton *)startButton{
    if (_startButton == nil) {
        _startButton = [[UIButton alloc] initWithFrame:CGRectZero];
        [_startButton setTitle:@"开始" forState:UIControlStateNormal];
        [_startButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _startButton.backgroundColor = [UIColor colorWithRed:42/255.f green:130/255.f blue:228/255.f alpha:1];
        [_startButton addTarget:self action:@selector(gotoStartButton) forControlEvents:UIControlEventTouchUpInside];
        
        
    }
    return _startButton;
}
- (NSMutableArray *)actionArray{
    if (_actionArray == nil) {
        _actionArray = [[NSMutableArray alloc] init];
    }
    return _actionArray;
}

@end
