//
//  UntitedNetworkHelper.m
//  TestLiveFrameDemo
//
//  Created by artmkt on 2021/5/27.
//

#import "UntitedNetworkHelper.h"

@implementation UntitedNetworkHelper

+ (instancetype)shareInstance{
    static UntitedNetworkHelper *_shareInstance = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _shareInstance = [[UntitedNetworkHelper alloc] init];
        [_shareInstance configure];
    });
    return _shareInstance;
}

- (void)configure{
//    self.requestUrl = @"http://172.16.3.228:7105/api/"; // 测试
//    self.requestUrl = @"https://eh5.spiderid.cn/api/";  // 线上环境

    self.requestUrl = @"";
    
}
- (void)requestHTTPMethod:(NSString *)httpMenthod relativePath:(NSString *)relativePath params:(NSDictionary *)params successBlock:(NWSuccessBlock)successBlock failBlock:(NWFailureBlock)failBlock{
    NSMutableString *paramString = [[NSMutableString alloc] initWithCapacity:0];
    for (int i = 0; i < params.allKeys.count; i++) {
        NSString *key = params.allKeys[i];
        [paramString appendString:[NSString stringWithFormat:@"%@=%@",key,params[key]]];
        if (i < params.allKeys.count - 1) {
            [paramString appendString:@"&"];
        }
    }
    
    
//    NSString *urlString = [NSString stringWithFormat:@"%@%@", self.requestUrl, relativePath];
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:relativePath]];
    [request setValue:@"appkey" forHTTPHeaderField:@"5bf90f68ba261b38405d16e0"];
    [request setValue:@"secretKey" forHTTPHeaderField:@"123456"];
    
    [request addValue:@"application/json; charset=utf-8" forHTTPHeaderField:@"Content-Type"];

    request.HTTPMethod = httpMenthod;
    request.timeoutInterval = 1.f;
    
    request.HTTPBody = [NSJSONSerialization dataWithJSONObject:params options:0 error:nil];
    
//    NSURLSessionConfiguration *config =[NSURLSessionConfiguration defaultSessionConfiguration];
//    NSURLSession *session = [NSURLSession sessionWithConfiguration:config];
//    
    NSURLSessionTask *datatask = [[NSURLSession sharedSession] dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
       
        if (!error) {
            if (successBlock) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    NSDictionary *responseObject = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
                    successBlock(responseObject);
                });
                
            }
        }else{
            if (failBlock) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    failBlock(error);
                });
            }
        }
        
    }];
    
    [datatask resume];
}
- (void)requestGetRelativePath:(NSString *)relativePath WithParams:(nonnull id)parameters success:(NWSuccessBlock)successBlock failure:(NWFailureBlock)failureBlock{
    NSMutableString *mutableUrl = [[NSMutableString alloc] initWithString:[NSString stringWithFormat:@"%@%@", self.requestUrl, relativePath]];
    if ([parameters allKeys]) {
        [mutableUrl appendString:@"?"];
        for (id key in parameters) {
            NSString *value = [[parameters objectForKey:key] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
            [mutableUrl appendString:[NSString stringWithFormat:@"%@=%@&", key, value]];
        }
    }

    NSString *urlEnCode = [[mutableUrl substringToIndex:mutableUrl.length - 1] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
//    NSURLRequest *urlRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:urlEnCode]];
    NSURLRequest *urlRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:urlEnCode] cachePolicy:NSURLRequestReloadIgnoringLocalAndRemoteCacheData timeoutInterval:5];
    NSURLSession *session = [NSURLSession sharedSession];
    
    NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:urlRequest completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        dispatch_async(dispatch_get_main_queue(), ^{

            NSHTTPURLResponse *urlResponse = (NSHTTPURLResponse *)response;
            if (urlResponse.statusCode == 200) {
                NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:nil];
                successBlock(dic);
            }else{
//                failureBlock(error);
                if (data != nil) {
                    NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
                    if (responseObj == nil) {
                        responseObj = @{@"message":@"请求失败，请重试！"};
                    }
                    if (failureBlock) {
                        failureBlock(error);
                    }
                }else{
                    if (failureBlock) {
                        failureBlock(error);
                    }
                }
            }
            
           
        });

    }];
    
    [dataTask resume];
}
- (void)requestGetRelativePath:(NSString *)relativePath withParams:(nonnull id)parameters withHeadDic:(NSDictionary *)headDic success:(NWSuccessBlock)successBlock failure:(NWBodyFailureBlock)failureBlock{
    NSMutableString *mutableUrl = [[NSMutableString alloc] initWithString:[NSString stringWithFormat:@"%@%@", self.requestUrl, relativePath]];
    if (parameters != nil) {
//        DLog(@"111");
        if ([parameters allKeys]) {
//            DLog(@"222");
            [mutableUrl appendString:@"?"];
            for (id key in parameters) {
                NSString *value = [[parameters objectForKey:key] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
                [mutableUrl appendString:[NSString stringWithFormat:@"%@=%@&", key, value]];
            }
        }
    }
    
    NSString *urlEnCode;
    if (parameters == nil) {
       urlEnCode = [mutableUrl stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];

    }else{
        urlEnCode = [[mutableUrl substringToIndex:mutableUrl.length - 1] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];

    }
//    DLog(@"%@ == %@",mutableUrl,parameters);

    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:urlEnCode]];

    if (headDic != nil) {
       for (NSString *key in headDic.allKeys) {
           [request addValue:headDic[key] forHTTPHeaderField:key];
       }
   }

    NSURLSession *session = [NSURLSession sharedSession];
    NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            NSHTTPURLResponse *urlResponse = (NSHTTPURLResponse *)response;

            if (urlResponse.statusCode == 200) {
                NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
//                NSLog(@"responseObj === %@ statusCode=== %ld",responseObj,(long)urlResponse.statusCode);
                successBlock(responseObj);
            }else{
                if (data != nil) {
                    NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
//                    DLog(@"responseObj === %@ statusCode=== %ld",responseObj,(long)urlResponse.statusCode);
                    int code = [responseObj[@"code"] intValue];
//                    ErrorMessageViewController *errorVC = [[ErrorMessageViewController alloc] init];
//                    UIViewController *currentVC = [self topViewController];
                    if (code == 10100 || code == 10101 || code == 10102 || code == 10129 || code == 10130) {
//                        [UnitidProgressHUD dismiss];

                        // 该认证会话token 已被使用 // 认证会话token已失效 // 本次认证超时失效，请重试  // 本次认证超时失效，请重试 //当前ip访问次数超过限制 // 验证失败。。。
//                        errorVC.responseMessage = responseObj[@"message"];
//                        errorVC.resultString = @"ERROR";
//                        [currentVC.navigationController pushViewController:errorVC animated:YES];
                        
                    }else{
                        if (responseObj == nil) {
                            responseObj = @{@"message":@"请求失败，请重试！"};
                        }
                        if (failureBlock) {
                            failureBlock(responseObj);
                        }
                    }
                    
                }else{
                    if (failureBlock) {
                        failureBlock(@{@"message":@"请求失败，请重试！"});
                    }
                }
                
            }
           
        });

    }];
    [dataTask resume];
}
- (void)requestGET:(NSString *)relativePath body:(NSDictionary *)params successBlock:(NWSuccessBlock)successBlock failBlock:(NWFailureBlock)failBlock{
    [self requestHTTPMethod:@"GET" relativePath:relativePath params:params successBlock:^(NSDictionary * _Nonnull data) {
        if (successBlock) {
            return successBlock(data);
        }
    } failBlock:^(NSError * _Nonnull error) {
        if (failBlock) {
            return failBlock(error);
        }
    }];
}

- (void)requestPOST:(NSString *)relativePath params:(NSDictionary *)params successBlock:(NWSuccessBlock)successBlock failBlock:(NWFailureBlock)failBlock{
    [self requestHTTPMethod:@"POST" relativePath:relativePath params:params successBlock:^(NSDictionary * _Nonnull data) {
        if (successBlock) {
            return successBlock(data);
        }
    } failBlock:^(NSError * _Nonnull error) {
        if (failBlock) {
            failBlock(error);
        }
    }];
}

//NWBodyFailureBlock
- (void)requestJsonPost:(NSString *)relativePath params:(NSDictionary *)params successBlock:(NWSuccessBlock)successBlock failBlock:(NWBodyFailureBlock)failBlock{
    NSString *urlString;
    if (![relativePath containsString:@"online-liveness/submit"]) {
        urlString = [NSString stringWithFormat:@"%@%@",self.requestUrl,relativePath];

    }else{
        urlString = relativePath;
    }
//    DLog(@"%@",urlString);
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:urlString]];
    request.HTTPMethod = @"POST";
    [request addValue:@"application/json; charset=utf-8" forHTTPHeaderField:@"Content-Type"];
    request.HTTPBody = [NSJSONSerialization dataWithJSONObject:params options:0 error:nil];
    request.timeoutInterval = 10.f;
    NSURLSessionTask *dataTask = [[NSURLSession sharedSession] dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            NSHTTPURLResponse *urlResponse = (NSHTTPURLResponse *)response;
            if (urlResponse.statusCode == 200) {
                NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
//                NSLog(@"responseObj === %@ statusCode=== %ld",responseObj,(long)urlResponse.statusCode);
                successBlock(responseObj);
            }else{
                if (data != nil) {
                    NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
                    int code = [responseObj[@"code"] intValue];
//                    ErrorMessageViewController *errorVC = [[ErrorMessageViewController alloc] init];
//                    UIViewController *currentVC = [self topViewController];
                    if (code == 10100 || code == 10101 || code == 10102 || code == 10129 || code == 10130) {
//                        [UnitidProgressHUD dismiss];
//                        // 该认证会话token 已被使用 // 认证会话token已失效 // 本次认证超时失效，请重试  // 本次认证超时失效，请重试 //当前ip访问次数超过限制 // 验证失败。。。
//                        errorVC.responseMessage = responseObj[@"message"];
//                        errorVC.resultString = @"ERROR";
//                        [currentVC.navigationController pushViewController:errorVC animated:YES];
                        
                    }else{
                        if (responseObj == nil) {
                            responseObj = @{@"message":@"请求失败，请重试！"};
                        }
                        if (failBlock) {
                            failBlock(responseObj);
                        }
                    }
                }else{
                    if (failBlock) {
                        failBlock(@{@"message":@"请求失败，请重试！"});
                    }
                }
                
            }
        });

    }];
    [dataTask resume];
}
- (void)requestJsonPost:(NSString *)relativePath headDic:(NSDictionary *)headDic bodyParams:(NSDictionary *)params successBlock:(NWSuccessBlock)successBlock failBlock:(NWBodyFailureBlock)failBlock{
    NSString *urlString = [NSString stringWithFormat:@"%@%@",self.requestUrl,relativePath];
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:urlString]];
    request.HTTPMethod = @"POST";
    [request addValue:@"application/json; charset=utf-8" forHTTPHeaderField:@"Content-Type"];
    if (headDic != nil) {
        for (NSString *key in headDic.allKeys) {
            [request addValue:headDic[key] forHTTPHeaderField:key];
        }
    }
    request.HTTPBody = [NSJSONSerialization dataWithJSONObject:params options:0 error:nil];
    request.timeoutInterval = 10.f;
    NSURLSessionTask *dataTask = [[NSURLSession sharedSession] dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        dispatch_async(dispatch_get_main_queue(), ^{
           NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *)response;
            
            if (httpResponse.statusCode == 200) {
                NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
//                NSLog(@"responseObj === %@ statusCode=== %ld",responseObj,(long)httpResponse.statusCode);

                successBlock(responseObj);
            }else{
                if (data == nil) {
                    if (failBlock) {
                        failBlock(@{@"message":@"请求失败，请重试！"});
                    }
                }else{
                    NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
//                    NSLog(@"responseObj === %@ statusCode=== %ld",responseObj,(long)httpResponse.statusCode);
                    int code = [responseObj[@"code"] intValue];
//                    ErrorMessageViewController *errorVC = [[ErrorMessageViewController alloc] init];
//                    UIViewController *currentVC = [self topViewController];
                    if (code == 10100 || code == 10101 || code == 10102 || code == 10129 || code == 10130) {
//                        [UnitidProgressHUD dismiss];
//
//                        // 该认证会话token 已被使用 // 认证会话token已失效 // 本次认证超时失效，请重试  // 本次认证超时失效，请重试 //当前ip访问次数超过限制 // 验证失败。。。
//                        errorVC.responseMessage = responseObj[@"message"];
//                        errorVC.resultString = @"ERROR";
//                        [currentVC.navigationController pushViewController:errorVC animated:YES];
                        
                    }else{
                        if (responseObj == nil) {
                            responseObj = @{@"message":@"请求失败，请重试！"};
                        }
                        if (failBlock) {
                            failBlock(responseObj);
                        }
                    }
                }
                
            }
            
        });

    }];
    [dataTask resume];
}
- (void)requestPostHeadDic:(NSDictionary *)headDic withParam:(NSDictionary *)parameters success:(NWSuccessBlock)successBlock failure:(NWFailureBlock)failureBlock{
    

    NSMutableString *mutableUrl = [[NSMutableString alloc] initWithString:[NSString stringWithFormat:@"%@%@", self.requestUrl, @"person-api/identity/idcard/ocr"]];


    if ([parameters allKeys]) {
        [mutableUrl appendString:@"?"];
        for (id key in parameters) {
            NSString *value = [[parameters objectForKey:key] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
            [mutableUrl appendString:[NSString stringWithFormat:@"%@=%@&", key, value]];
        }
    }
    NSString *urlEnCode = [[mutableUrl substringToIndex:mutableUrl.length - 1] stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];


    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:urlEnCode]
                                                           cachePolicy:NSURLRequestReloadIgnoringLocalCacheData
                                                       timeoutInterval:15];
    
    if (headDic != nil) {
        for (NSString *key in headDic.allKeys) {
            [request addValue:headDic[key] forHTTPHeaderField:key];
        }
    }
        
    
    request.HTTPMethod = @"POST";
    request.timeoutInterval = 15.f;
    
    NSURLSessionTask *dataTask = [[NSURLSession sharedSession] dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            
            if (!error) {
                if (successBlock) {
                    NSDictionary *responseObj = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
                    successBlock(responseObj);
                }
            }else{
                if (failureBlock) {
                    failureBlock(error);
                }
            }
        });

    }];
    [dataTask resume];

}



@end
